local weapons = {}

local function exclude(weapon_name_id)
  weapons[weapon_name_id] = weapons[weapon_name_id] or {}
  weapons[weapon_name_id].drop_magazine = false
end

local list = {
  "rpg7",
  "ray",
  "slap",
  "china",
  "m79",
  "m32",
  "r870",
  "serbu",
  "m37",
  "mosin",
  "c96",
  "x_c96",
  "chinchilla",
  "x_chinchilla",
  "mateba",
  "x_mateba",
  "korth",
  "x_korth"
}

for _, weapon_name_id in ipairs(list) do
  exclude(weapon_name_id)
end

local function can_drop_magazine(weapon_name_id)
  local weapon = weapons[weapon_name_id]
  return not (weapon and weapon.drop_magazine == false)
end

Hooks:PostHook(PlayerStandard, "_start_action_reload", "post_action_reload_mag", function(self, t)

  local weapon = self._equipped_unit:base()

  if weapon and weapon:can_reload() and can_drop_magazine(weapon:get_name_id()) then
    weapon:drop_magazine_object()
  end

end)
